package com.sun.corba.se.impl.naming.cosnaming;

import java.util.Properties;
import com.sun.corba.se.impl.orbutil.CorbaResourceUtil;
import org.omg.CORBA.SystemException;
import org.omg.CORBA.Object;
import org.omg.CORBA.ORB;
import com.sun.corba.se.impl.logging.NamingSystemException;

public class TransientNameServer
{
    private static boolean debug;
    static NamingSystemException wrapper;
    
    public static void trace(String x) {
        if (TransientNameServer.debug) {
            System.out.println(x);
        }
    }
    
    public static void initDebug(String[] array) {
        if (TransientNameServer.debug) {
            return;
        }
        int i = 0;
        while (i < array.length) {
            if (array[i].equalsIgnoreCase("-debug")) {
                TransientNameServer.debug = true;
                return;
            }
            ++i;
        }
        TransientNameServer.debug = false;
        return;
    }
    
    private static org.omg.CORBA.Object initializeRootNamingContext(ORB orb) {
        try {
            return new TransientNameService((com.sun.corba.se.spi.orb.ORB)orb).initialNamingContext();
        }
        catch (SystemException ex) {
            throw TransientNameServer.wrapper.transNsCannotCreateInitialNcSys(ex);
        }
        catch (Exception ex2) {
            throw TransientNameServer.wrapper.transNsCannotCreateInitialNc(ex2);
        }
    }
    
    public static void main(String[] obj) {
        initDebug(obj);
        boolean n = false;
        boolean n2 = false;
        int n3 = 0;
        try {
            trace("Transient name server started with args " + obj);
            Properties properties = System.getProperties();
            properties.put("com.sun.CORBA.POA.ORBServerId", "1000000");
            properties.put("org.omg.CORBA.ORBClass", "com.sun.corba.se.impl.orb.ORBImpl");
            try {
                String property = System.getProperty("org.omg.CORBA.ORBInitialPort");
                if (property != null && property.length() > 0) {
                    n3 = Integer.parseInt(property);
                    if (n3 == 0) {
                        n2 = true;
                        throw TransientNameServer.wrapper.transientNameServerBadPort();
                    }
                }
                if (System.getProperty("org.omg.CORBA.ORBInitialHost") != null) {
                    n = true;
                    throw TransientNameServer.wrapper.transientNameServerBadHost();
                }
            }
            catch (NumberFormatException ex) {}
            int i = 0;
            while (i < obj.length) {
                if (obj[i].equals("-ORBInitialPort") && i < obj.length - 1) {
                    n3 = Integer.parseInt(obj[i + 1]);
                    if (n3 == 0) {
                        n2 = true;
                        throw TransientNameServer.wrapper.transientNameServerBadPort();
                    }
                }
                if (obj[i].equals("-ORBInitialHost")) {
                    n = true;
                    throw TransientNameServer.wrapper.transientNameServerBadHost();
                }
                ++i;
            }
            if (n3 == 0) {
                n3 = 900;
                properties.put("org.omg.CORBA.ORBInitialPort", Integer.toString(n3));
            }
            properties.put("com.sun.CORBA.POA.ORBPersistentServerPort", Integer.toString(n3));
            ORB init = ORB.init(obj, properties);
            trace("ORB object returned from init: " + init);
            org.omg.CORBA.Object initializeRootNamingContext = initializeRootNamingContext(init);
            ((com.sun.corba.se.org.omg.CORBA.ORB)init).register_initial_reference("NamingService", initializeRootNamingContext);
            String object_to_string = null;
            if (initializeRootNamingContext != null) {
                object_to_string = init.object_to_string(initializeRootNamingContext);
            }
            else {
                NamingUtils.errprint(CorbaResourceUtil.getText("tnameserv.exception", n3));
                NamingUtils.errprint(CorbaResourceUtil.getText("tnameserv.usage"));
                System.exit(1);
            }
            trace("name service created");
            System.out.println(CorbaResourceUtil.getText("tnameserv.hs1", object_to_string));
            System.out.println(CorbaResourceUtil.getText("tnameserv.hs2", n3));
            System.out.println(CorbaResourceUtil.getText("tnameserv.hs3"));
            Object o = new Object();
            synchronized (o) {
                o.wait();
            }
        }
        catch (Exception ex2) {
            if (!(n == 0)) {
                NamingUtils.errprint(CorbaResourceUtil.getText("tnameserv.invalidhostoption"));
            }
            else if (!(n2 == 0)) {
                NamingUtils.errprint(CorbaResourceUtil.getText("tnameserv.orbinitialport0"));
            }
            else {
                NamingUtils.errprint(CorbaResourceUtil.getText("tnameserv.exception", n3));
                NamingUtils.errprint(CorbaResourceUtil.getText("tnameserv.usage"));
            }
            ex2.printStackTrace();
        }
    }
    
    private TransientNameServer() {
    }
    
    static {
        TransientNameServer.debug = false;
        TransientNameServer.wrapper = NamingSystemException.get("naming");
    }
}
